﻿<##
# create a hyperV Virtual machine, niall brady https://www.windows-noob.com 2017/11/10
# prompts for Virtual Machine name and Virtual Switch name and the Generation type (1 is for Legacy, 2 is for UEFI), if the switchname already exists it will simply use it
#>

# define the following variables for your VM defaults

$BootDevice = "NetworkAdapter" # valid options are Floppy | CD | IDE | LegacyNetworkAdapter | NetworkAdapter | VHD
$NewVhdSizeBytes = 127GB
$MemoryStartupBytes = 2048MB
$HyperVPath = "C:\HyperV\" # where do you want to store the VM
$Count = 2 # number of CPUs
$Reserve = 10 # CPU Virtual Machine Reserve (Percentage)
$Maximum = 75 # CPU Virtual Machine Limit (Percentage)
$RelativeWeight = 200 # CPU Relative Weight
$CheckpointType = "Standard" # Type of Checkpoint to take, valid options are Disabled| Production | Production-Only | Standard
$DynamicMemory = $false # Type of memory, valid options are $true or $false, but remember that $staticmemory must also be set accordingly
$StaticMemory = $true


# don't mess with the script below

  If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole(`
        [Security.Principal.WindowsBuiltInRole] “Administrator”))

    {
        Write-Warning “You do not have Administrator rights to run this script!`nPlease re-run this script as an Administrator!”
        Break
    }

$Name =  Read-Host "Please enter the Virtual Machine name "
if ($Name -eq ""){$Name="New Virtual Machine"} ; if ($Name -eq $NULL){$Name="New Virtual Machine"}

$Path = $HyperVPath + $name
$VirtualMachinePath = $Path
$SnapshotFilePath = $Path
$SmartPagingFilePath = $Path
$Path = $Path + "\Virtual Hard Disks"

$SwitchName =  Read-Host "Please enter the Virtual Switch name "
if ($SwitchName -eq ""){$SwitchName="New Virtual Switch"} ; if ($SwitchName -eq $NULL){$SwitchName="New Virtual Switch"}
$VMSwitch = Get-VMSwitch -name $SwitchName -ErrorAction SilentlyContinue



#write-host $VMSwitch.Count

if ($VMSwitch.Count -ge '1') { 
Write-Host "That Virtual Switch name already exists, will use it rather than create it."
}
else
{Write-Host "That Virtual Switch name doesn't exist, will create it." 
# create new HyperV switch, can be Private, External, Internal
New-VMSwitch -Name $SwitchName -SwitchType Private
 }
 
$Generation =  Read-Host "Please enter the Generation type (1 or 2) "
if ($Generation -eq ""){$Generation="2"} ; if ($Generation -eq $NULL){$Generation="2"}

if ($Generation -eq "1"){$BootDevice="LegacyNetworkAdapter"}
$ComputerName = "Localhost"
$NewVHDPath = $Path + "\$Name.vhdx"

# check if DIR to store the VM already exists, otherwise create it
 if (Test-Path $Path){
                
                Write-Host "HyperV virtual machine directory: '$Path' already exists, please remove and try again or use a different Virtual Machine name, aborting ..." -nonewline
		        break
                } else {
                            # if the dir doesn't exist, write that fact and then continue the loop	    
	                        write-host "The path '$Path' didn't exist, creating."    
                            New-Item $Path -type directory
                        }

# create the VM
New-VM -Name $Name -MemoryStartupBytes $MemoryStartupBytes -Generation $Generation -BootDevice $BootDevice -ComputerName $ComputerName -NewVHDPath $NewVHDPath -NewVhdSizeBytes $NewVhdSizeBytes -SwitchName $SwitchName -Verbose
# move the storage
Move-VMStorage $Name -VirtualMachinePath $VirtualMachinePath -SnapshotFilePath $SnapshotFilePath -SmartPagingFilePath $SmartPagingFilePath
# change processor settings
Set-VMProcessor $Name -Count $Count -Reserve $Reserve -Maximum $Maximum -RelativeWeight $RelativeWeight
# change the Checkpoint type
set-vm $Name -CheckpointType $CheckpointType
# change the memory type
If ($DynamicMemory) {
set-vm $Name  -DynamicMemory}
set-vm $Name  -StaticMemory
